###################################################
### chunk number 1: faithful
###################################################
#line 235 "d:/Rcompile/CRANpkg/local/2.12/mixtools/inst/doc/vignette.Rnw"
library(mixtools)
data(faithful)
attach(faithful)


###################################################
### chunk number 2: geyser
###################################################
#line 244 "d:/Rcompile/CRANpkg/local/2.12/mixtools/inst/doc/vignette.Rnw"
hist(waiting, main="Time between Old Faithful eruptions",
     xlab="Minutes",  ylab="", cex.main=1.5, cex.lab=1.5, cex.axis=1.4)


###################################################
### chunk number 3: normmixEM
###################################################
#line 420 "d:/Rcompile/CRANpkg/local/2.12/mixtools/inst/doc/vignette.Rnw"
wait1 <- normalmixEM(waiting, lambda = .5, mu = c(55, 80), sigma = 5)


###################################################
### chunk number 4: geyserEM eval=FALSE
###################################################
## #line 429 "d:/Rcompile/CRANpkg/local/2.12/mixtools/inst/doc/vignette.Rnw"
## plot(wait1, density=TRUE, cex.axis=1.4, cex.lab=1.4, cex.main=1.8,
##      main2="Time between Old Faithful eruptions", xlab2="Minutes")


###################################################
### chunk number 5: geyserEM
###################################################
#line 437 "d:/Rcompile/CRANpkg/local/2.12/mixtools/inst/doc/vignette.Rnw"
for(i in 1:2){
  file=paste("geyserEM", i, ".pdf", sep="")
  pdf(file=file, paper="special", width=6, height=6)
  plot(wait1, whichplots=i, cex.axis = 1.4, cex.lab = 1.4, cex.main =
       1.8,   main2 = "Time between Old Faithful eruptions", xlab2 =
       "Minutes")
  dev.off()
  cat("\\includegraphics{", file, "}\n", sep="")
}


###################################################
### chunk number 6: geyserestimates
###################################################
#line 462 "d:/Rcompile/CRANpkg/local/2.12/mixtools/inst/doc/vignette.Rnw"
wait1[c("lambda", "mu", "sigma")]


###################################################
### chunk number 7: geysersummary
###################################################
#line 468 "d:/Rcompile/CRANpkg/local/2.12/mixtools/inst/doc/vignette.Rnw"
summary(wait1)


###################################################
### chunk number 8: cutpoint
###################################################
#line 551 "d:/Rcompile/CRANpkg/local/2.12/mixtools/inst/doc/vignette.Rnw"
data("Waterdata")
cutpts <- 10.5*(-6:6)
watermult <- makemultdata(Waterdata, cuts = cutpts)


###################################################
### chunk number 9: multmixEM
###################################################
#line 560 "d:/Rcompile/CRANpkg/local/2.12/mixtools/inst/doc/vignette.Rnw"
set.seed(15)
theta4 <- matrix(runif(56), ncol = 14)
theta3 <- theta4[1:3,]
mult3 <- multmixEM(watermult, lambda = rep(1, 3)/3, theta = theta3)
mult4 <- multmixEM (watermult, lambda = rep (1, 4) / 4, theta = theta4)


###################################################
### chunk number 10:  eval=FALSE
###################################################
## #line 573 "d:/Rcompile/CRANpkg/local/2.12/mixtools/inst/doc/vignette.Rnw"
## cdf3 <- compCDF(Waterdata, mult3$posterior, lwd=2, lab=c(7, 5, 7),
##                 xlab="Angle in degrees", ylab="Component CDFs",
##                 main="Three-Component Solution")
## cdf4 <- compCDF(Waterdata, mult4$posterior, lwd=2, lab=c(7, 5, 7),
##                 xlab="Angle in degrees", ylab="Component CDFs",
##                 main="Four-Component Solution")


###################################################
### chunk number 11: cutpointplots
###################################################
#line 582 "d:/Rcompile/CRANpkg/local/2.12/mixtools/inst/doc/vignette.Rnw"
pdf(file="WDcutpoint3comp.pdf", paper="special", width=8, height=8)
cdf3 <- compCDF(Waterdata, mult3$posterior, lwd=3,
                xlab="Angle in degrees", lab=c(7, 5, 7), ylab="Component CDFs",
                main="Three-Component Solution", cex.axis=1.4, cex.lab=1.5,
                cex.main=1.5)
ltext <- paste(round(mult3$lam*100, 1), "%", sep="")
legend("bottomright", legend=ltext, pch=15:17, cex=1.5, pt.cex=1.35)
y <- compCDF(Waterdata, mult3$posterior, x=cutpts, makeplot=F)
for(i in 1:3) points(cutpts, y[i,], pch=14+i, cex=1.35)
dev.off()
pdf(file="WDcutpoint4comp.pdf", paper="special", width=8, height=8)
cdf4 <- compCDF(Waterdata, mult4$posterior, lwd=3,
                xlab="Angle in degrees", lab=c(7, 5, 7),
                ylab="Component CDFs", main="Four-Component Solution",
                cex.axis=1.4, cex.lab=1.5, cex.main=1.5)
ltext <- paste(round(mult4$lam*100,1), "%", sep="")
legend("bottomright", legend=ltext, pch=15:18, cex=1.5, pt.cex=1.35)
y <- compCDF(Waterdata, mult4$posterior, x=cutpts, makeplot=F)
for(i in 1:4) points(cutpts, y[i,], pch=14+i, cex=1.35)
dev.off()


###################################################
### chunk number 12: summarymult4
###################################################
#line 621 "d:/Rcompile/CRANpkg/local/2.12/mixtools/inst/doc/vignette.Rnw"
summary(mult4)


###################################################
### chunk number 13: spsymmplots
###################################################
#line 799 "d:/Rcompile/CRANpkg/local/2.12/mixtools/inst/doc/vignette.Rnw"
pdf(file="spsymmfig1.pdf", paper="special", width=8, height=8)
par(mar=0.1+c(5,4.2,4,1.8))
plot(wait1, which = 2, cex.axis = 1.4, cex.lab = 1.5, cex.main = 1.5,
     main2 = "Time between Old Faithful eruptions", xlab2 = "Minutes")
wait2 <- spEMsymloc(waiting, mu0 = c(55, 80))
plot(wait2, lty = 2, newplot = FALSE, addlegend = FALSE)
dev.off()
pdf(file="spsymmfig2.pdf", paper="special", width=8, height=8)
par(mar=0.1+c(5,4.2,4,1.8))
wait2a <- spEMsymloc(waiting, mu0 = c(55, 80), bw = 1)
wait2b <- spEMsymloc(waiting, mu0 = c(55, 80), bw = 6)
plot(wait2a, lty = 1, addlegend = FALSE, cex.axis = 1.4, cex.lab = 1.5,
     cex.main = 1.5, title = "Time between Old Faithful eruptions",
     xlab = "Minutes")
plot(wait2b, lty = 2, newplot = FALSE, addlegend = FALSE)
dev.off()


###################################################
### chunk number 14: plotspsymm eval=FALSE
###################################################
## #line 836 "d:/Rcompile/CRANpkg/local/2.12/mixtools/inst/doc/vignette.Rnw"
## plot(wait1, which = 2, cex.axis = 1.4, cex.lab = 1.4, cex.main = 1.8,
##      main2 = "Time between Old Faithful eruptions", xlab2 = "Minutes")
## wait2 <- spEMsymloc(waiting, mu0 = c(55, 80))
## plot(wait2, lty = 2, newplot = FALSE, addlegend = FALSE)


###################################################
### chunk number 15: bandwidth
###################################################
#line 849 "d:/Rcompile/CRANpkg/local/2.12/mixtools/inst/doc/vignette.Rnw"
bw.nrd0(waiting)


###################################################
### chunk number 16: plotbweffect eval=FALSE
###################################################
## #line 855 "d:/Rcompile/CRANpkg/local/2.12/mixtools/inst/doc/vignette.Rnw"
## wait2a <- spEMsymloc(waiting, mu0 = c(55, 80), bw = 1)
## wait2b <- spEMsymloc(waiting, mu0 = c(55, 80), bw = 6)
## plot(wait2a, lty = 1, addlegend = FALSE, cex.axis = 1.4,
##      cex.lab = 1.4, cex.main = 1.8, xlab = "Minutes",
##      title = "Time between Old Faithful eruptions")
## plot(wait2b, lty = 2, newplot = FALSE, addlegend = FALSE)


###################################################
### chunk number 17: gaussexample
###################################################
#line 906 "d:/Rcompile/CRANpkg/local/2.12/mixtools/inst/doc/vignette.Rnw"
m <- 2; r <- 3; n <- 300; S <- 100
lambda <- c(0.4, 0.6)
mu <- matrix(c(0, 0, 0, 3, 4, 5), m, r, byrow = TRUE)
sigma <- matrix(rep(1, 6), m, r, byrow = TRUE)


###################################################
### chunk number 18: gaussinitial
###################################################
#line 917 "d:/Rcompile/CRANpkg/local/2.12/mixtools/inst/doc/vignette.Rnw"
centers <- matrix(c(0, 0, 0, 4, 4, 4), 2, 3, byrow = TRUE)
ISE <- matrix(0, m, r, dimnames = list(Components = 1:m, Blocks = 1:r))
nblabsw <- 0


###################################################
### chunk number 19: sqMISE
###################################################
#line 925 "d:/Rcompile/CRANpkg/local/2.12/mixtools/inst/doc/vignette.Rnw"
set.seed(1000)
for (mc in 1:S) {
  x <- rmvnormmix(n, lambda, mu, sigma)
  a <- npEM(x, centers, verb = FALSE, samebw = FALSE)
  if (a$lambda[1] > a$lambda[2]) nblabsw <- nblabsw + 1
  for (j in 1:m) {
     for (k in 1:r) {
     ISE[j, k] <- ISE[j, k] + ise.npEM(a, j, k, dnorm,
         lower = mu[j, k] - 5, upper = mu[j, k] + 5, plots = FALSE,
         mean = mu[j, k], sd = sigma[j, k])$value
    }
  }
}
MISE <- ISE/S
print(sqMISE <- sqrt(MISE))


###################################################
### chunk number 20: summarygauss
###################################################
#line 945 "d:/Rcompile/CRANpkg/local/2.12/mixtools/inst/doc/vignette.Rnw"
summary(a)


###################################################
### chunk number 21: plotgauss3rm eval=FALSE
###################################################
## #line 953 "d:/Rcompile/CRANpkg/local/2.12/mixtools/inst/doc/vignette.Rnw"
## plot(a)


###################################################
### chunk number 22: gauss3rm
###################################################
#line 957 "d:/Rcompile/CRANpkg/local/2.12/mixtools/inst/doc/vignette.Rnw"
pdf("gauss3rm.pdf", paper="special", width=10, height=5)
par(mfrow=c(1,3))
plot(a)
dev.off()


###################################################
### chunk number 23: true5rm
###################################################
#line 991 "d:/Rcompile/CRANpkg/local/2.12/mixtools/inst/doc/vignette.Rnw"
pdf("truepdf5rm_block1.pdf")
par(mar=0.1+c(5,4.2,4,1.5))
x <- seq(-10, 25, len=250)
plot(x, .4* dt(x, 2, 0) + .6 * dt(x, 10, 8), type="l", lwd=3, col=2,
     cex.axis=1.4, cex.lab=1.5, cex.main=1.5, main="Block 1", xlab="",
     ylab="Density")
lines (x, .4*dt(x, 2, 0), lwd=4, lty=2)
lines (x, .6*dt(x, 10, 8), lwd=4, lty=2)
dev.off()
pdf("truepdf5rm_block2.pdf")
par(mar=0.1+c(5,4.2,4,1.5))
x <- seq(0, 1, len=250)
plot(x, .4 + .6 * dbeta(x, 1, 5), type="l", lwd=3, col=2, cex.axis=1.4,
   cex.lab=1.5, cex.main=1.5, main="Block 2", xlab="", ylab="Density",
   ylim= c(0, 3.4))
lines (x, rep(.4, 250), lwd=4, lty=2)
lines (x, .6*dbeta(x, 1, 5), lwd=4, lty=2)
dev.off()


###################################################
### chunk number 24: parameters5rm
###################################################
#line 1028 "d:/Rcompile/CRANpkg/local/2.12/mixtools/inst/doc/vignette.Rnw"
m <- 2; r <- 5
lambda <- c(0.4, 0.6)
df <- c(2, 10); ncp <- c(0, 8)
sh1 <- c(1, 1) ; sh2 <- c(1, 5)


###################################################
### chunk number 25: generate5rm
###################################################
#line 1036 "d:/Rcompile/CRANpkg/local/2.12/mixtools/inst/doc/vignette.Rnw"
n <- 300; z <- sample(m, n, rep = TRUE, prob = lambda)
r1 <- 3; z2 <- rep(z, r1)
x1 <- matrix(rt(n * r1, df[z2], ncp[z2]), n, r1)
r2 <- 2; z2 <- rep(z, r2)
x2 <- matrix(rbeta(n * r2, sh1[z2], sh2[z2]), n, r2)
x <- cbind(x1, x2)


###################################################
### chunk number 26: npEM5rm
###################################################
#line 1050 "d:/Rcompile/CRANpkg/local/2.12/mixtools/inst/doc/vignette.Rnw"
id <- c(rep(1, r1), rep(2, r2))
centers <- matrix(c(0, 0, 0, 1/2, 1/2, 4, 4, 4, 1/2, 1/2), m, r,
                  byrow = TRUE)
b <- npEM(x, centers, id, eps = 1e-8, verb = FALSE, samebw = FALSE)


###################################################
### chunk number 27: plot5rm eval=FALSE
###################################################
## #line 1059 "d:/Rcompile/CRANpkg/local/2.12/mixtools/inst/doc/vignette.Rnw"
## plot(b, breaks = 15)


###################################################
### chunk number 28: plot5rmcommands
###################################################
#line 1066 "d:/Rcompile/CRANpkg/local/2.12/mixtools/inst/doc/vignette.Rnw"
pdf("npEM5rm.pdf", width=8, height=5)
par(mfrow=c(1,2))
plot(b, breaks = 15)

dev.off()


###################################################
### chunk number 29: ISEnpEM5rm eval=FALSE
###################################################
## #line 1087 "d:/Rcompile/CRANpkg/local/2.12/mixtools/inst/doc/vignette.Rnw"
## par(mfrow=c(2,2))
## for (j in 1:2){
##   ise.npEM(b, j, 1, truepdf = dt, lower = ncp[j] - 10,
##            upper = ncp[j] + 10, df = df[j], ncp = ncp[j])
##   ise.npEM(b, j, 2, truepdf = dbeta, lower = -0.5,
##            upper = 1.5,  shape1 = sh1[j], shape2 = sh2[j])
## }


###################################################
### chunk number 30: plotISEnpEM5rm
###################################################
#line 1097 "d:/Rcompile/CRANpkg/local/2.12/mixtools/inst/doc/vignette.Rnw"
options(warn=-1)
pdf("ISEnpEM5rm.pdf", width=8, height=8)
par(mfrow = c(2, 2))
for (j in 1:2){
  ise.npEM(b, j, 1, truepdf = dt, lower = ncp[j] - 10,
           upper = ncp[j] + 10, df = df[j], ncp = ncp[j])
  ise.npEM(b, j, 2, truepdf = dbeta, lower = -0.5,
           upper = 1.5,  shape1 = sh1[j], shape2 = sh2[j])
}
dev.off()


###################################################
### chunk number 31: gnpdata
###################################################
#line 1180 "d:/Rcompile/CRANpkg/local/2.12/mixtools/inst/doc/vignette.Rnw"
data("CO2data")
attach(CO2data)
pdf("gnpdata.pdf")
par(mar=0.1+c(5,4.2,4,1.5))
plot(GNP, CO2, xlab="Gross National Product",
     ylab=expression(paste(CO[2]," per Capita")),
     cex.lab=1.5, cex.main=1.5, cex.axis=1.4,
     main="1996 GNP and Emissions Data")
text(GNP, CO2, country, adj=c(.5,-.5))
dev.off()


###################################################
### chunk number 32: 
###################################################
#line 1276 "d:/Rcompile/CRANpkg/local/2.12/mixtools/inst/doc/vignette.Rnw"
data("CO2data")
attach(CO2data)


###################################################
### chunk number 33: CO2reg
###################################################
#line 1280 "d:/Rcompile/CRANpkg/local/2.12/mixtools/inst/doc/vignette.Rnw"
CO2reg <- regmixEM(CO2, GNP, lambda = c(1, 3) / 4,
                   beta = matrix(c(8, -1, 1, 1), 2, 2), sigma = c(2, 1))


###################################################
### chunk number 34: summaryCO2reg
###################################################
#line 1289 "d:/Rcompile/CRANpkg/local/2.12/mixtools/inst/doc/vignette.Rnw"
summary(CO2reg)


###################################################
### chunk number 35: plotCO2reg eval=FALSE
###################################################
## #line 1301 "d:/Rcompile/CRANpkg/local/2.12/mixtools/inst/doc/vignette.Rnw"
## plot(CO2reg, density = TRUE, alpha = 0.01, cex.main = 1.5, cex.lab = 1.5,
##      cex.axis = 1.4)


###################################################
### chunk number 36: trueplotCO2reg
###################################################
#line 1309 "d:/Rcompile/CRANpkg/local/2.12/mixtools/inst/doc/vignette.Rnw"
for(i in 1:2){
    file=paste("CO2reg", i, ".pdf", sep="")
    pdf(file=file, paper="special", width=6, height=6)
    plot(CO2reg, whichplots=i, alpha = 0.01, cex.main = 1.5, cex.lab = 1.5,
         cex.axis = 1.4)
    dev.off()
    cat("\\includegraphics{", file, "}\n", sep="")
}


###################################################
### chunk number 37: CO2igle
###################################################
#line 1425 "d:/Rcompile/CRANpkg/local/2.12/mixtools/inst/doc/vignette.Rnw"
CO2igle <- regmixEM.loc(CO2, GNP, beta = CO2reg$beta, sigma = CO2reg$sigma,
                        lambda = matrix(.5, 28, 2), kern.l = "Beta",
                        kernl.h = 25, kernl.g = 3)


###################################################
### chunk number 38: CO2iglesummary
###################################################
#line 1436 "d:/Rcompile/CRANpkg/local/2.12/mixtools/inst/doc/vignette.Rnw"
summary(CO2igle)


###################################################
### chunk number 39: lamplot eval=FALSE
###################################################
## #line 1443 "d:/Rcompile/CRANpkg/local/2.12/mixtools/inst/doc/vignette.Rnw"
## plot(GNP, CO2igle$post[,1], xlab = "GNP", cex.axis = 1.4, cex.lab = 1.5,
##   ylab = "Final posterior probabilities")
## lines(sort(GNP), CO2igle$lambda[order(GNP), 1], col=2)
## abline(h = CO2igle$lambda[1], lty = 2)


###################################################
### chunk number 40: truelamplot
###################################################
#line 1450 "d:/Rcompile/CRANpkg/local/2.12/mixtools/inst/doc/vignette.Rnw"
pdf("lamplot.pdf")
plot(GNP, CO2igle$post[,1], xlab = "GNP", cex.axis = 1.4, cex.lab = 1.5,
  ylab = "Final posterior probabilities")
lines(sort(GNP), CO2igle$lambda[order(GNP), 1], col=2, lwd=2)
abline(h = CO2igle$lambda[1], lty = 2, lwd=2)
dev.off()


###################################################
### chunk number 41: CO2boot
###################################################
#line 1511 "d:/Rcompile/CRANpkg/local/2.12/mixtools/inst/doc/vignette.Rnw"
set.seed(123)
CO2boot <- boot.se(CO2reg, B = 100)


###################################################
### chunk number 42: bootresults
###################################################
#line 1523 "d:/Rcompile/CRANpkg/local/2.12/mixtools/inst/doc/vignette.Rnw"
rbind(range(CO2boot$beta[1,]), range(CO2boot$beta[2,]))


###################################################
### chunk number 43: CO2bootse
###################################################
#line 1528 "d:/Rcompile/CRANpkg/local/2.12/mixtools/inst/doc/vignette.Rnw"
CO2boot[c("lambda.se", "beta.se", "sigma.se")]


###################################################
### chunk number 44: modelsel
###################################################
#line 1576 "d:/Rcompile/CRANpkg/local/2.12/mixtools/inst/doc/vignette.Rnw"
#line 551 "d:/Rcompile/CRANpkg/local/2.12/mixtools/inst/doc/vignette.Rnw#from line#1576#"
data("Waterdata")
cutpts <- 10.5*(-6:6)
watermult <- makemultdata(Waterdata, cuts = cutpts)
#line 1577 "d:/Rcompile/CRANpkg/local/2.12/mixtools/inst/doc/vignette.Rnw"
set.seed(10)
multmixmodel.sel(watermult, comps = 1:4, epsilon = 0.001)


